commit 788ce11efbe71581724128b308f869e947d207ab
Author: Vaclav Honzik <vaclavhonzik98@gmail.com>
Date:   Fri Apr 22 19:59:01 2022 +0200

    tracking tool start
    
    re #9547

diff --git a/frontend/src/App.tsx b/frontend/src/App.tsx
index e760950..921cc39 100644
--- a/frontend/src/App.tsx
+++ b/frontend/src/App.tsx
@@ -10,6 +10,7 @@ import { RootState } from './features/redux/store'
 import Login from './features/Auth/Login'
 import CatalogItemDetail from './features/Catalog/CatalogItemDetail'
 import Navigation from './features/Navigation/Navigation'
+import TrackingTool from './features/TrackingTool/TrackingTool'
 
 const App = () => {
     const theme: Theme = useSelector((state: RootState) => state.theme.theme)
@@ -17,18 +18,19 @@ const App = () => {
     return (
         <ThemeProvider theme={theme}>
             <Navigation>
-                    <Container>
-                        <Routes>
-                            <Route path="/" element={<Home />} />
-                            <Route path="/catalog" element={<Catalog />} />
-                            <Route
-                                path="/catalog/:itemId"
-                                element={<CatalogItemDetail />}
-                            />
-                            <Route path="/login" element={<Login />} />
-                            <Route path="*" element={<NotFound />} />
-                        </Routes>
-                    </Container>
+                <Container>
+                    <Routes>
+                        <Route path="/" element={<Home />} />
+                        <Route path="/catalog" element={<Catalog />} />
+                        <Route
+                            path="/catalog/:itemId"
+                            element={<CatalogItemDetail />}
+                        />
+                        <Route path="/login" element={<Login />} />
+                        <Route path="/map" element={<TrackingTool />} />
+                        <Route path="*" element={<NotFound />} />
+                    </Routes>
+                </Container>
             </Navigation>
         </ThemeProvider>
     )
diff --git a/frontend/src/features/TrackingTool/TrackingTool.tsx b/frontend/src/features/TrackingTool/TrackingTool.tsx
new file mode 100644
index 0000000..ddc4b81
--- /dev/null
+++ b/frontend/src/features/TrackingTool/TrackingTool.tsx
@@ -0,0 +1,62 @@
+import { Button, Grid, Stack, Typography } from '@mui/material'
+import { Fragment } from 'react'
+import AddIcon from '@mui/icons-material/Add'
+import { MapContainer, Marker, Popup, TileLayer } from 'react-leaflet'
+import mapConfig from '../../config/mapConfig'
+
+// Page with tracking tool
+const TrackingTool = () => {
+
+    return (
+        <Fragment>
+            <Typography variant="h3" sx={{ mb: 2 }} fontWeight="bold">
+                Tracking Tool
+            </Typography>
+
+            <Grid container>
+                <Grid item xs={12} md={4}>
+                    <Stack
+                        direction="row"
+                        alignItems="flex-start"
+                        spacing={2}
+                        sx={{ m: 0, p: 0 }}
+                    >
+                        <Typography
+                            variant="h5"
+                            sx={{ mb: 2 }}
+                            fontWeight="500"
+                        >
+                            Upload:
+                        </Typography>
+                        <Button
+                            variant="contained"
+                            color="primary"
+                            startIcon={<AddIcon />}
+                        >
+                            Plaintext
+                        </Button>
+                        <Button
+                            variant="contained"
+                            color="primary"
+                            startIcon={<AddIcon />}
+                        >
+                            File
+                        </Button>
+                    </Stack>
+                </Grid>
+                <Grid item xs={12} md={8} style={{minHeight: '60vh', maxHeight: '100vh', width: '100%'}}>
+                    <MapContainer
+                        center={[mapConfig.defaultCoordinates[0], mapConfig.defaultCoordinates[1]]}
+                        zoom={mapConfig.defaultZoom}
+                        style={{ height: '100%', minHeight: '100%' }}
+                    >
+                    <TileLayer attribution={mapConfig.attribution} url={mapConfig.url} />
+                        
+                    </MapContainer>
+                </Grid>
+            </Grid>
+        </Fragment>
+    )
+}
+
+export default TrackingTool